package hexentric;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class LazyLOSDialog extends JDialog
{
	public LazyLOSDialog(Frame parent)
	{
		super(parent);
		
		//{{INIT_CONTROLS
		setResizable(false);
		getContentPane().setLayout(null);
		getContentPane().setFont(new Font("Dialog", Font.PLAIN, 11));
		getContentPane().setBackground(new java.awt.Color(182,182,107));
		setSize(204,156);
		setVisible(false);
		tf_hf.setSelectionColor(new java.awt.Color(204,204,255));
		tf_hf.setSelectedTextColor(java.awt.Color.black);
		tf_hf.setCaretColor(java.awt.Color.black);
		tf_hf.setColumns(4);
		tf_hf.setHorizontalAlignment(com.sun.java.swing.SwingConstants.CENTER);
		tf_hf.setAlignmentY(0.0F);
		tf_hf.setAlignmentX(0.0F);
		tf_hf.setDisabledTextColor(new java.awt.Color(153,153,153));
		tf_hf.setToolTipText("Height of Firer");
		tf_hf.setDoubleBuffered(true);
		getContentPane().add(tf_hf);
		tf_hf.setBackground(java.awt.Color.white);
		tf_hf.setFont(new Font("SansSerif", Font.PLAIN, 11));
		tf_hf.setBounds(16,27,32,18);
		tf_ro.setSelectionColor(new java.awt.Color(204,204,255));
		tf_ro.setSelectedTextColor(java.awt.Color.black);
		tf_ro.setCaretColor(java.awt.Color.black);
		tf_ro.setColumns(4);
		tf_ro.setHorizontalAlignment(com.sun.java.swing.SwingConstants.CENTER);
		tf_ro.setAlignmentY(0.0F);
		tf_ro.setAlignmentX(0.0F);
		tf_ro.setDisabledTextColor(new java.awt.Color(153,153,153));
		tf_ro.setToolTipText("Range of Firer to Obstacle");
		tf_ro.setDoubleBuffered(true);
		getContentPane().add(tf_ro);
		tf_ro.setBackground(java.awt.Color.white);
		tf_ro.setFont(new Font("SansSerif", Font.PLAIN, 11));
		tf_ro.setBounds(51,27,32,18);
		tf_ho.setSelectionColor(new java.awt.Color(204,204,255));
		tf_ho.setSelectedTextColor(java.awt.Color.black);
		tf_ho.setCaretColor(java.awt.Color.black);
		tf_ho.setColumns(4);
		tf_ho.setHorizontalAlignment(com.sun.java.swing.SwingConstants.CENTER);
		tf_ho.setAlignmentY(0.0F);
		tf_ho.setAlignmentX(0.0F);
		tf_ho.setDisabledTextColor(new java.awt.Color(153,153,153));
		tf_ho.setToolTipText("Height of Obstacle");
		tf_ho.setDoubleBuffered(true);
		getContentPane().add(tf_ho);
		tf_ho.setBackground(java.awt.Color.white);
		tf_ho.setFont(new Font("SansSerif", Font.PLAIN, 11));
		tf_ho.setBounds(86,27,32,18);
		tf_rt.setSelectionColor(new java.awt.Color(204,204,255));
		tf_rt.setSelectedTextColor(java.awt.Color.black);
		tf_rt.setCaretColor(java.awt.Color.black);
		tf_rt.setColumns(4);
		tf_rt.setHorizontalAlignment(com.sun.java.swing.SwingConstants.CENTER);
		tf_rt.setAlignmentY(0.0F);
		tf_rt.setAlignmentX(0.0F);
		tf_rt.setDisabledTextColor(new java.awt.Color(153,153,153));
		tf_rt.setToolTipText("Range of Obstacle to Target");
		tf_rt.setDoubleBuffered(true);
		getContentPane().add(tf_rt);
		tf_rt.setBackground(java.awt.Color.white);
		tf_rt.setFont(new Font("SansSerif", Font.PLAIN, 11));
		tf_rt.setBounds(121,27,32,18);
		tf_ht.setSelectionColor(new java.awt.Color(204,204,255));
		tf_ht.setSelectedTextColor(java.awt.Color.black);
		tf_ht.setCaretColor(java.awt.Color.black);
		tf_ht.setColumns(4);
		tf_ht.setHorizontalAlignment(com.sun.java.swing.SwingConstants.CENTER);
		tf_ht.setAlignmentY(0.0F);
		tf_ht.setAlignmentX(0.0F);
		tf_ht.setDisabledTextColor(new java.awt.Color(153,153,153));
		tf_ht.setToolTipText("Height of Target");
		tf_ht.setDoubleBuffered(true);
		getContentPane().add(tf_ht);
		tf_ht.setBackground(java.awt.Color.white);
		tf_ht.setFont(new Font("SansSerif", Font.PLAIN, 11));
		tf_ht.setBounds(156,27,32,18);
		cb_c.setText("Crest Line");
		cb_c.setActionCommand("Crest Line");
		cb_c.setAlignmentY(0.5F);
		getContentPane().add(cb_c);
		cb_c.setForeground(new java.awt.Color(50,50,24));
		cb_c.setBackground(new java.awt.Color(182,182,107));
		cb_c.setFont(new Font("Dialog", Font.PLAIN, 11));
		cb_c.setBounds(67,52,70,19);
		b_calc.setText("Calculate");
		b_calc.setActionCommand("Calculate");
		b_calc.setAlignmentY(0.5F);
		getContentPane().add(b_calc);
		b_calc.setForeground(new java.awt.Color(50,50,24));
		b_calc.setBackground(new java.awt.Color(182,182,107));
		b_calc.setFont(new Font("Dialog", Font.BOLD, 11));
		b_calc.setBounds(53,75,98,22);
		l_result.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		getContentPane().add(l_result);
		l_result.setBackground(java.awt.Color.orange);
		l_result.setForeground(java.awt.Color.black);
		l_result.setFont(new Font("Dialog", Font.BOLD, 12));
		l_result.setBounds(14,105,176,18);
		jl0.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jl0.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jl0.setText("F");
		getContentPane().add(jl0);
		jl0.setForeground(new java.awt.Color(50,50,24));
		jl0.setFont(new Font("Dialog", Font.BOLD, 12));
		jl0.setBounds(16,8,32,18);
		jl1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jl1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jl1.setText("---");
		getContentPane().add(jl1);
		jl1.setForeground(new java.awt.Color(50,50,24));
		jl1.setFont(new Font("Dialog", Font.BOLD, 12));
		jl1.setBounds(52,6,32,18);
		jl2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jl2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jl2.setText("O");
		getContentPane().add(jl2);
		jl2.setForeground(new java.awt.Color(50,50,24));
		jl2.setFont(new Font("Dialog", Font.BOLD, 12));
		jl2.setBounds(86,8,32,18);
		jl3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jl3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jl3.setText("---");
		getContentPane().add(jl3);
		jl3.setForeground(new java.awt.Color(50,50,24));
		jl3.setFont(new Font("Dialog", Font.BOLD, 12));
		jl3.setBounds(122,6,32,18);
		jl4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jl4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jl4.setText("T");
		getContentPane().add(jl4);
		jl4.setForeground(new java.awt.Color(50,50,24));
		jl4.setFont(new Font("Dialog", Font.BOLD, 12));
		jl4.setBounds(156,8,32,18);
		l_help.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		l_help.setText("?");
		l_help.setToolTipText("Help");
		getContentPane().add(l_help);
		l_help.setForeground(new java.awt.Color(50,50,24));
		l_help.setFont(new Font("Dialog", Font.BOLD, 9));
		l_help.setBounds(187,-1,12,16);
		//}}
		
		//{{REGISTER_LISTENERS
		Listener0 listener0 = new Listener0();
		this.addWindowListener(listener0);
		b_calc.addActionListener(listener0);
		Listener1 listener1 = new Listener1();
		l_help.addMouseListener(listener1);
		//}}
	}

	public LazyLOSDialog()
	{
		this((Frame)null);
	}

	public LazyLOSDialog(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new LazyLOSDialog()).setVisible(true);
	}
	
	private void close()
	{
		try { this.setVisible(false); } catch (Exception e) {}
	}
	
	private void openHelp()
	{
	    HelpDialog help = new HelpDialog();
		help.setModal(false);
		help.setTitle("LazyLOS Help");
		help.show();
	}
	
	private void calc()
	{
	    try
	    {
		    float fhf = Float.valueOf(tf_hf.getText()).floatValue();
		    float fro = Float.valueOf(tf_ro.getText()).floatValue();
		    float fho = Float.valueOf(tf_ho.getText()).floatValue();
		    float frt = Float.valueOf(tf_rt.getText()).floatValue();
		    float fht = Float.valueOf(tf_ht.getText()).floatValue();
		    if ((fho>fhf && fho>fht) || (fho==fhf && fho>fht) || (fho>fhf && fho==fht))
		    {
		        l_result.setForeground(new java.awt.Color(160,32,32));
		        l_result.setText("No LOS");
		        return;
		    }
            int hf = f2i(fhf), ro = f2i(fro), ho = f2i(fho), rt = f2i(frt), ht = f2i(fht);		
		    int highest = hf, range = ro, shadow = rt;
		    if (ht>highest)
		    {
		        highest = ht;
		        range = rt;
		        shadow = ro;
		    }
		    int c  = 0;
		    if (!cb_c.isSelected()) c++;
		    int bh = (2*ho)+(range/5)-hf-ht+c;
		    if (cb_c.isSelected())
		        if (bh<0) bh=0;
		    else
		        if (bh<1) bh=1;
		    String response = new String("");
		    if (bh>0)
		    {
		        response = String.valueOf(bh)+" Blind Hex";
		        if (bh>1) response += "es";
		        if (hf==highest)
		            response+=" F---T ";
		        else
		            response+=" T---F ";
		    }
		    if (bh<shadow)
		    {
		        response+="LOS OK";
		        l_result.setForeground(new java.awt.Color(32,160,32));
		    }
		    else
		    {
	            response+="No LOS";
		        l_result.setForeground(new java.awt.Color(160,32,32));
		    }
		    l_result.setText(response);
		}
		catch (Exception e) { l_result.setText(""); }
	}
	
	private int f2i(float f)
	{
	    return (int)f;
	}

	//{{DECLARE_CONTROLS
	javax.swing.JTextField tf_hf = new javax.swing.JTextField();
	javax.swing.JTextField tf_ro = new javax.swing.JTextField();
	javax.swing.JTextField tf_ho = new javax.swing.JTextField();
	javax.swing.JTextField tf_rt = new javax.swing.JTextField();
	javax.swing.JTextField tf_ht = new javax.swing.JTextField();
	javax.swing.JCheckBox cb_c = new javax.swing.JCheckBox();
	javax.swing.JButton b_calc = new javax.swing.JButton();
	javax.swing.JLabel l_result = new javax.swing.JLabel();
	javax.swing.JLabel jl0 = new javax.swing.JLabel();
	javax.swing.JLabel jl1 = new javax.swing.JLabel();
	javax.swing.JLabel jl2 = new javax.swing.JLabel();
	javax.swing.JLabel jl3 = new javax.swing.JLabel();
	javax.swing.JLabel jl4 = new javax.swing.JLabel();
	javax.swing.JLabel l_help = new javax.swing.JLabel();
	//}}
	
	class Listener0 extends WindowAdapter implements ActionListener
	{
		public void windowClosing(WindowEvent event)
		{
			Object object = event.getSource();
			if (object == LazyLOSDialog.this)
				close();
		}
		
		public void actionPerformed(ActionEvent event)
		{
			Object object = event.getSource();
			if (object == b_calc)
				calc();
		}
	}
	
	class Listener1 extends MouseAdapter
	{
		public void mouseClicked(MouseEvent event)
		{
			if (event.getSource() == l_help)
				openHelp();
		}
	}
}